local debug = false
local recording, recordStartTime, recordedTime = 0,0,0 -- recorder vars
local seconds, TimeThatTimmerStarted, TimeSinceTimerIsRunning = 0,0,0 -- timer vars

function start()
	if recording == 0 then	-- record, if we arent already
		recordedTime = 0
		recordStartTime = math.ceil(GetTime())
		if debug then print("Now recording") end
		Stopwatch_StartCountdown(0,0,0.5) -- show
		Stopwatch_Clear() -- clear
		Stopwatch_Play() -- play
		recording = 1
	else -- if we did record until now, init and play timer
		recordedTime = (math.ceil(GetTime()) - recordStartTime) -- this is owr recorded time
		if debug then print("Recorded time is: " .. recordedTime) end
		Stopwatch_Clear() -- stop and clear the stop watch
		TimeThatTimmerStarted = math.ceil(GetTime()) -- get time the timer got started
		play(recordedTime) -- start timer
		recording, recordStartTime = 0,0 -- stop recording and reset start time
	end
end

-- play stopwatch
function play(seconds)
	Stopwatch_StartCountdown(0, 0, seconds)
	Stopwatch_Play()
end

-- check if timer is expired
local function tick(self,elapsed)
	if recording == 0 then -- only if we arent recording
		TimeSinceTimerIsRunning = (math.ceil(GetTime()) - TimeThatTimmerStarted)
		if TimeSinceTimerIsRunning == recordedTime then -- if timmer expires
			TimeThatTimmerStarted = math.ceil(GetTime())
			if debug then print("Timer expiered! New Cycle...") end
			play(recordedTime) -- repeat to start timer
		end
	end
end

-- ticker frame
local f = CreateFrame("frame")
f:SetScript("OnUpdate", tick)

-- slash commands
SLASH_STOPWATCHTIMER1, SLASH_STOPWATCHTIMER2 = '/swt', '/stopwatchtimer';
function SlashCmdList.STOPWATCHTIMER(msg)
start();
end

-- keybinding variables
BINDING_HEADER_STOPWATCHTIMER = "StopWatchTimer"
BINDING_NAME_STOPWATCHTIMER_PLAY = "Record and Play"